> ## Documentation Index
> Fetch the complete documentation index at: https://ubicloud.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Upgrade a kubernetes cluster



## OpenAPI

````yaml /api-reference/openapi.yml post /project/{project_id}/location/{location}/kubernetes-cluster/{kubernetes_cluster_reference}/upgrade
openapi: 3.0.3
info:
  description: API for managing resources on Ubicloud
  title: Clover API
  version: 0.1.0
  contact:
    url: https://www.ubicloud.com/
    email: support@ubicloud.com
  license:
    name: GNU Affero General Public License v3.0 (AGPL-3.0)
    url: https://www.gnu.org/licenses/agpl-3.0.en.html
servers:
  - url: https://api.ubicloud.com
security:
  - BearerAuth: []
tags:
  - description: Firewall Operations
    name: Firewall
  - description: Firewall Rule Operations
    name: Firewall Rule
  - description: Inference API Key Operations
    name: Inference Api Key
  - description: Inference Endpoint Operations
    name: Inference Endpoint
  - description: Load Balancer Operations
    name: Load Balancer
  - description: Login Operations
    name: Login
  - description: Machine Image Operations
    name: Machine Image
  - description: Postgres Database Operations
    name: Postgres Database
  - description: Postgres Firewall Rule Operations
    name: Postgres Firewall Rule
  - description: Postgres Metric Destination
    name: Postgres Metric Destination
  - description: Postgres Log Destination
    name: Postgres Log Destination
  - description: Private Subnet Operations
    name: Private Subnet
  - description: Project Operations
    name: Project
  - description: Virtual Machine Operations
    name: Virtual Machine
  - description: Private Location Operations
    name: Private Location
  - description: Kubernetes Cluster Operations
    name: Kubernetes Cluster
  - description: SSH Public Key Operations
    name: SSH Public Key
  - description: GitHub Operations
    name: GitHub
  - description: Audit Log Operations
    name: Audit Log
paths:
  /project/{project_id}/location/{location}/kubernetes-cluster/{kubernetes_cluster_reference}/upgrade:
    parameters:
      - $ref: '#/components/parameters/project_id'
      - $ref: '#/components/parameters/location'
      - $ref: '#/components/parameters/kubernetes_cluster_reference'
    post:
      tags:
        - Kubernetes Cluster
      summary: Upgrade a kubernetes cluster
      operationId: upgradeKubernetesCluster
      responses:
        '200':
          $ref: '#/components/responses/KubernetesCluster'
        default:
          $ref: '#/components/responses/Error'
components:
  parameters:
    project_id:
      description: ID of the project
      in: path
      name: project_id
      required: true
      schema:
        type: string
        example: pjkkmx0f2vke4h36nk9cm8v8q0
        pattern: ^pj[0-9a-hj-km-np-tv-z]{24}$
    location:
      description: The Ubicloud location/region
      in: path
      name: location
      required: true
      schema:
        type: string
        example: eu-central-h1
    kubernetes_cluster_reference:
      description: Kubernetes cluster ID or name
      examples:
        id:
          value: kcn30gjk1d1e2jj34v9x0dq4rp
        name:
          value: kubernetes-cluster-name
      in: path
      name: kubernetes_cluster_reference
      required: true
      schema:
        $ref: '#/components/schemas/Reference'
  responses:
    KubernetesCluster:
      description: A KubernetesCluster
      content:
        application/json:
          schema:
            type: object
            additionalProperties: false
            allOf:
              - $ref: '#/components/schemas/KubernetesCluster'
    Error:
      description: An error response
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  schemas:
    Reference:
      description: Resource ID or name
      type: string
      pattern: ^[a-z0-9](?:[a-z0-9\-]{0,61}[a-z0-9])?$
    KubernetesCluster:
      type: object
      properties:
        cp_node_count:
          description: Number of control plane nodes
          type: integer
        cp_vms:
          type: array
          items:
            $ref: '#/components/schemas/Vm'
        display_state:
          description: State of the KubernetesCluster
          type: string
        id:
          description: ID of the KubernetesCluster
          type: string
          example: kcqxhqbg86sj0ng5e9ck5n191z
          pattern: ^kc[0-9a-hj-km-np-tv-z]{24}$
        location:
          description: Location of the KubernetesCluster
          type: string
          example: eu-central-h1
        name:
          description: Name of the KubernetesCluster
          type: string
          example: my-cluster-name
        node_size:
          description: Size of each control plane node
          type: string
        nodepools:
          type: array
          items:
            $ref: '#/components/schemas/KubernetesNodepool'
        services_load_balancer_url:
          description: Services
          type: string
          nullable: true
        version:
          description: Version of the KubernetesCluster
          type: string
      additionalProperties: false
      required:
        - cp_node_count
        - id
        - location
        - name
        - node_size
        - version
    Error:
      type: object
      properties:
        error:
          type: object
          additionalProperties: false
          properties:
            code:
              type: integer
              example: 401
            message:
              type: string
              example: There was an error logging in
            type:
              type: string
              example: InvalidCredentials
            details:
              type: object
              nullable: true
          required:
            - code
            - message
            - type
      additionalProperties: false
      required:
        - error
    Vm:
      type: object
      properties:
        boot_image:
          description: Boot image of the VM
          type: string
        id:
          description: ID of the VM
          type: string
          example: vmhfy8gff8c67hasb0eez2k1pd
          pattern: ^vm[0-9a-hj-km-np-tv-z]{24}$
        ip4:
          description: IPv4 address
          type: string
          format: ipv4
          nullable: true
        ip4_enabled:
          description: Whether IPv4 is enabled
          type: boolean
        ip6:
          description: IPv6 address
          type: string
          format: ipv6
          nullable: true
        location:
          description: Location of the VM
          type: string
          example: eu-central-h1
        name:
          description: Name of the VM
          type: string
          example: my-vm-name
        size:
          description: Size of the underlying VM
          type: string
        state:
          description: State of the VM
          type: string
        storage_size_gib:
          description: Storage size in GiB
          type: integer
        unix_user:
          description: Unix user of the VM
          type: string
      additionalProperties: false
      required:
        - boot_image
        - id
        - ip4
        - ip4_enabled
        - ip6
        - location
        - name
        - size
        - state
        - storage_size_gib
        - unix_user
    KubernetesNodepool:
      type: object
      properties:
        kubernetes_cluster_id:
          description: Parent KubernetesCluster id
          type: string
          example: kcqxhqbg86sj0ng5e9ck5n191z
          pattern: ^kc[0-9a-hj-km-np-tv-z]{24}$
        id:
          description: ID of the KubernetesNodepool
          type: string
          example: knqxhqbg86sj0ng5e9ck5n191z
          pattern: ^kn[0-9a-hj-km-np-tv-z]{24}$
        name:
          description: Name of the KubernetesNodepool
          type: string
          example: my-nodepool-name
        node_count:
          description: Number of worker nodes
          type: integer
        node_size:
          description: Size of each worker node
          type: string
        vms:
          description: Worker VMs definition
          type: array
          items:
            $ref: '#/components/schemas/Vm'
      additionalProperties: false
      required:
        - kubernetes_cluster_id
        - id
        - name
        - node_count
        - node_size
  securitySchemes:
    BearerAuth:
      bearerFormat: JWT
      scheme: bearer
      type: http

````